Package com.emc.documentum.rest.dfc

# Interface SysObjectManager

All Superinterfaces:
  `ObjectManager`

public interface SysObjectManager extends ObjectManager
The sysobject manager.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `SysObject`
  `cancelCheckOut(String id)`
  Deprecated.
  since 7.3, please use `VersioningManager.cancelCheckOut(String)`
  `<T extends SysObject>
  T`
  `cancelCheckOut(String id, Class<T> targetClass)`
  Deprecated.
  since 7.3, please use `VersioningManager.cancelCheckOut(String, Class)`
  `boolean`
  `checkEnableChangePermit(String objectId)`
  Check whether the current login user can update the permission set of a specified sysobject.
  `SysObject`
  `checkIn(String chronicleId, String id, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, InputStream contentStream, int pageNumber, String format, boolean retainLock, String comment)`
  Deprecated.
  Since 7.3, please use the generic method `VersioningManager.checkIn(String, ContentfulObject, String, CheckinPolicy, boolean, int, String, boolean, String)`.
  `<T extends SysObject>
  T`
  `checkIn(String chronicleId, String id, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, InputStream contentStream, int pageNumber, String format, boolean retainLock, String comment, Class<T> targetClass)`
  Deprecated.
  since 7.3, please use `VersioningManager.checkIn(String, String, String, CheckinPolicy, boolean, InputStream, int, String, boolean, String, Class)`
  `SysObject`
  `checkIn(String chronicleId, String id, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, InputStream contentStream, int pageNumber, String format, long contentLength, String charset, boolean retainLock, String comment)`
  Deprecated.
  since 7.3, please use `VersioningManager.checkIn(String, String, String, CheckinPolicy, boolean, InputStream, int, String, long, String, boolean, String)`
  `<T extends SysObject>
  T`
  `checkIn(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, boolean retainLock, String comment)`
  Deprecated.
  since 7.3, please use `VersioningManager.checkIn(String, SysObject, String, CheckinPolicy, boolean, boolean, String)`
  `<T extends ContentfulObject>
  T`
  `checkIn(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, int pageNumber, String format, boolean retainLock, String comment)`
  Deprecated.
  since 7.3, please use `VersioningManager.checkIn(String, ContentfulObject, String, CheckinPolicy, boolean, int, String, boolean, String)`
  `<T extends ContentfulObject>
  T`
  `checkInWithContents(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, int pageNumber, boolean retainLock, String comment)`
  Deprecated.
  since 7.3, please use `VersioningManager.checkInWithContents(String, ContentfulObject, String, CheckinPolicy, boolean, int, boolean, String)`
  `<T extends ContentfulObject>
  T`
  `checkInWithRenditions(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, int pageNumber, boolean retainLock, String comment)`
  Deprecated.
  since 7.3, please use `VersioningManager.checkInWithRenditions(String, ContentfulObject, String, CheckinPolicy, boolean, int, boolean, String)`
  `SysObject`
  `checkOut(String id)`
  Deprecated.
  since 7.3, please use `VersioningManager.checkOut(String)`
  `<T extends SysObject>
  T`
  `checkOut(String id, Class<T> targetClass)`
  Deprecated.
  since 7.3, please use `VersioningManager.checkOut(String, Class)`
  `<T extends SysObject>
  T`
  `completeDcWrite(String objectId, InputStream completeResponse, Class<T> targetClass)`
  Complete the distributed content write.
  `SysObject`
  `copy(String objectId, String folderId, boolean deepCopy, boolean replicateVdChildren)`
  Deprecated.
  please use `copy(String, String, boolean, boolean, boolean, ContentfulObject)`
  `SysObject`
  `copy(String objectId, String folderId, boolean deepCopy, boolean replicateVdChildren, boolean retainAcl, ContentfulObject object)`
  Deprecated.
  since Feldspar 16.3, please use `copy(String, String, ContentfulObject, CopyOptions)`
  `SysObject`
  `copy(String objectId, String folderId, boolean deepCopy, boolean replicateVdChildren, ContentfulObject object)`
  Deprecated.
  please use `copy(String, String, boolean, boolean, boolean, ContentfulObject)`
  `<T extends SysObject>
  T`
  `copy(String objectId, String folderId, boolean deepCopy, boolean replicateVdChildren, Class<T> targetClass)`
  Deprecated.
  please use `copy(String, String, boolean, boolean, boolean, ContentfulObject)`
  `SysObject`
  `copy(String objectId, String folderId, ContentfulObject object, com.emc.documentum.rest.dfc.util.CopyOptions copyOptions)`
  Copy object into a folder
  `<T extends SysObject>
  T`
  `createSysObjectUnderParentFolder(T object, String parentId, boolean validateUnknown, AttributeView attributeView)`
  Create a sysobject under the parent folder.
  `<T extends SysObject>
  T`
  `createSysObjectUnderParentFolderWithRenditions(T object, String parentId, boolean validateUnknown, AttributeView attributeView)`
  Create a sysobject under the parent folder.
  `boolean`
  `deleteSysObject(String id, boolean deleteFolderChildren, boolean deleteMultiLinkedFolderChildren, DeleteVersionPolicy policy)`
  Delete a sysobject with advanced options
  `boolean`
  `deleteSysObjectTx(String id, boolean deleteFolderChildren, boolean deleteMultiLinkedFolderChildren, boolean deleteVirtualDocumentAllDescendant, DeleteVersionPolicy policy, BasicType... constrainedTypes)`
  This is the transactional version of `deleteSysObject(String, boolean, boolean, com.emc.documentum.rest.constant.DeleteVersionPolicy)` It supports a transactional context when the underlying object contains multiple children, this method ensures the ACID for the object.
  `boolean`
  `deleteSysObjectTx(String id, boolean deleteFolderChildren, boolean deleteMultiLinkedFolderChildren, DeleteVersionPolicy policy, BasicType... constrainedTypes)`
  This is the transactional version of `deleteSysObject(String, boolean, boolean, com.emc.documentum.rest.constant.DeleteVersionPolicy)` It supports a transactional context when the underlying object contains multiple children, this method ensures the ACID for the object.
  `boolean`
  `deleteSysObjectTxByQua(String qualification, boolean deleteFolderChildren, boolean deleteMultiLinkedFolderChildren, boolean deleteVirtualDocumentAllDescendant, DeleteVersionPolicy policy, BasicType... constrainedTypes)`
  This is the transactional version of `deleteSysObject(String, boolean, boolean, com.emc.documentum.rest.constant.DeleteVersionPolicy)` It supports a transactional context when the underlying object contains multiple children, this method ensures the ACID for the object.
  `boolean`
  `deleteSysObjectTxByQua(String qualification, boolean deleteFolderChildren, boolean deleteMultiLinkedFolderChildren, DeleteVersionPolicy policy, BasicType... constrainedTypes)`
  This is the transactional version of `deleteSysObject(String, boolean, boolean, com.emc.documentum.rest.constant.DeleteVersionPolicy)` It supports a transactional context when the underlying object contains multiple children, this method ensures the ACID for the object.
  `SysObject`
  `getCurrentVersion(String id)`
  Deprecated.
  since 7.3, please use `VersioningManager.getCurrentVersion(String)`
  `<T extends SysObject>
  T`
  `getCurrentVersion(String id, Class<T> targetClass)`
  Deprecated.
  since 7.3, please use `VersioningManager.getCurrentVersion(String, Class)`
  `PersistentObject`
  `getObjectById(String id, AttributeView attributeView, boolean includePermission, boolean includeVersionPolicy, BasicType... constrainedTypes)`
  Get persistent object by ID.
  `<T extends PersistentObject>
  T`
  `getObjectById(String id, AttributeView attributeView, boolean includePermission, boolean includeVersionPolicy, Class<T> targetClass, BasicType... constrainedTypes)`
  Get persistent object by ID.
  `Page<SysObject>`
  `getSysObjects(CollectionParam param, String objectType, boolean includeAllVersions)`
  `<T extends PersistentObject>
  T`
  `toPersistentObject(com.documentum.fc.client.IDfPersistentObject dfObject, AttributeView attributeView, Class<T> targetClass)`
  Convert DFC persistent object to REST `PersistentObject` with specified attribute view applied
  `<T extends PersistentObject>
  T`
  `toPersistentObject(com.documentum.fc.client.IDfPersistentObject dfObject, Class<T> targetClass)`
  Convert DFC persistent object to REST `PersistentObject` with all attribute view applied
  `<T extends SysObject>
  T`
  `validateAndCreateChildSysObjectRequestingDcWrite(T object, String folderId, long length, String format, String netLoc, boolean async, String completionUrlBase, boolean ipBasedNetworkLocationOpted, String validationPolicy)`
  Create a sysobject under the parent folder by requesting distributed content write URL(s).
  `<T extends SysObject>
  T`
  `validateAndCreateSysObjectUnderParentFolder(T object, String parentId, boolean validateUnknown, AttributeView attributeView, String constraintsValidationPolicy)`
  Create a sysobject under the parent folder.

  ### Methods inherited from interface com.emc.documentum.rest.dfc.ObjectManager

  `checkObjectExistence, createObject, deleteObject, getBasicObjectTypeById, getFolderAncestorsById, getFolderAncestorsById, getFolderByPath, getObjectById, getObjectById, getObjectByQualification, getObjectByQualification, updateObject, updateObjectByQualification, validateAndCreateObject, validateAndUpdateObject`

- ## Method Details

  - ### getObjectById

    PersistentObject getObjectById(String id, AttributeView attributeView, boolean includePermission, boolean includeVersionPolicy, BasicType... constrainedTypes) throws com.documentum.fc.common.DfException
    Get persistent object by ID.
    Parameters:
      `id` - The ID of persistent object
      `attributeView` - the attribute view
      `includePermission` - TRUE to include current login user's permission set on the target object
      `includeVersionPolicy` - TRUE to include available version for check in
      `constrainedTypes` - this object to get must belong to the type within the constrained type list; if null, no constrain.
    Returns:
      The persistent object with attributes
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### getObjectById

    <T extends PersistentObject> T getObjectById(String id, AttributeView attributeView, boolean includePermission, boolean includeVersionPolicy, Class<T> targetClass, BasicType... constrainedTypes) throws com.documentum.fc.common.DfException
    Get persistent object by ID.
    Type Parameters:
      `T` - the PersistentObject or its subclass
    Parameters:
      `id` - The ID of persistent object
      `attributeView` - the attribute view
      `includePermission` - TRUE to include current login user's permission set on the target object
      `includeVersionPolicy` - TRUE to include available version for check in
      `constrainedTypes` - this object to get must belong to the type within the constrained type list; if null, no constrain.
      `targetClass` - the return class instance type for the model
    Returns:
      The persistent object with attributes
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### createSysObjectUnderParentFolder

    <T extends SysObject> T createSysObjectUnderParentFolder(T object, String parentId, boolean validateUnknown, AttributeView attributeView) throws com.documentum.fc.common.DfException
    Create a sysobject under the parent folder. If the object has more than one content to be stored, then the content will be saved as primary contents for different pages.
    Type Parameters:
      `T` - the PersistentObject or its subclass
    Parameters:
      `object` - The persistent object with type and attributes
      `validateUnknown` - Indicate if to validate unknown attribute names; TRUE to validate and error occurs if there are unresolved attribute names; FALSE to ignore unresolved attribute names; Default is FALSE.
      `attributeView` - the attribute view
      `parentId` - The existing parent folder ID
    Returns:
      The newly created sysobject with ID and type only
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### validateAndCreateSysObjectUnderParentFolder

    <T extends SysObject> T validateAndCreateSysObjectUnderParentFolder(T object, String parentId, boolean validateUnknown, AttributeView attributeView, String constraintsValidationPolicy) throws com.documentum.fc.common.DfException
    Create a sysobject under the parent folder. If the object has more than one content to be stored, then the content will be saved as primary contents for different pages.
    Type Parameters:
      `T` - the PersistentObject or its subclass
    Parameters:
      `object` - The persistent object with type and attributes
      `validateUnknown` - Indicate if to validate unknown attribute names; TRUE to validate and error occurs if there are unresolved attribute names; FALSE to ignore unresolved attribute names; Default is FALSE.
      `attributeView` - the attribute view
      `parentId` - The existing parent folder ID
      `constraintsValidationPolicy` - the constraints validation policy need to be applied on the sysobject.
    Returns:
      The newly created sysobject with ID and type only
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### createSysObjectUnderParentFolderWithRenditions

    <T extends SysObject> T createSysObjectUnderParentFolderWithRenditions(T object, String parentId, boolean validateUnknown, AttributeView attributeView) throws com.documentum.fc.common.DfException
    Create a sysobject under the parent folder. If the object have more than one content to be stored, then the content will be saved as one primary and other renditions for the page 0.
    Type Parameters:
      `T` - the PersistentObject or its subclass
    Parameters:
      `object` - The persistent object with type and attributes
      `parentId` - The existing parent folder ID
      `validateUnknown` - Indicate if to validate unknown attribute names; TRUE to validate and error occurs if there are unresolved attribute names; FALSE to ignore unresolved attribute names; Default is FALSE.
      `attributeView` - the attribute view
    Returns:
      The newly created sysobject with ID and type only
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### deleteSysObject

    boolean deleteSysObject(String id, boolean deleteFolderChildren, boolean deleteMultiLinkedFolderChildren, DeleteVersionPolicy policy) throws com.documentum.fc.common.DfException
    Delete a sysobject with advanced options
    Parameters:
      `id` - The ID of the sysobject to be removed
      `deleteFolderChildren` - When working with folders, TRUE indicates to delete the folder and all of its descendants; False indicates just to delete the root folder.
      `deleteMultiLinkedFolderChildren` - When working with folders, TRUE indicates to delete the folder and all descendants, regardless of other folders into which they are linked; FALSE indicates to unlink folder descendants from the folder being deleted if the folder descendants have links to other folders, and to remove folder descendants that are only linked to the folder being deleted.
      `policy` - When working with documents, it indicates how to handle the versions.
    Returns:
      `true` if the object is deleted successfully
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### deleteSysObjectTx

    boolean deleteSysObjectTx(String id, boolean deleteFolderChildren, boolean deleteMultiLinkedFolderChildren, DeleteVersionPolicy policy, BasicType... constrainedTypes) throws com.documentum.fc.common.DfException
    This is the transactional version of `deleteSysObject(String, boolean, boolean, com.emc.documentum.rest.constant.DeleteVersionPolicy)` It supports a transactional context when the underlying object contains multiple children, this method ensures the ACID for the object.
    Parameters:
      `id` - The ID of the sysobject to be removed
      `deleteFolderChildren` - When working with folders, TRUE indicates to delete the folder and all of its descendants; False indicates just to delete the root folder.
      `deleteMultiLinkedFolderChildren` - When working with folders, TRUE indicates to delete the folder and all descendants, regardless of other folders into which they are linked; FALSE indicates to unlink folder descendants from the folder being deleted if the folder descendants have links to other folders, and to remove folder descendants that are only linked to the folder being deleted.
      `policy` - When working with documents, it indicates how to handle the versions.
      `constrainedTypes` - this object to delete must belong to the type within the constrained type list; if null, no constrain.
    Returns:
      `true` if the object is deleted successfully
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### deleteSysObjectTx

    boolean deleteSysObjectTx(String id, boolean deleteFolderChildren, boolean deleteMultiLinkedFolderChildren, boolean deleteVirtualDocumentAllDescendant, DeleteVersionPolicy policy, BasicType... constrainedTypes) throws com.documentum.fc.common.DfException
    This is the transactional version of `deleteSysObject(String, boolean, boolean, com.emc.documentum.rest.constant.DeleteVersionPolicy)` It supports a transactional context when the underlying object contains multiple children, this method ensures the ACID for the object.
    Parameters:
      `id` - The ID of the sysobject to be removed
      `deleteFolderChildren` - When working with folders, TRUE indicates to delete the folder and all of its descendants; False indicates just to delete the root folder.
      `deleteMultiLinkedFolderChildren` - When working with folders, TRUE indicates to delete the folder and all descendants, regardless of other folders into which they are linked; FALSE indicates to unlink folder descendants from the folder being deleted if the folder descendants have links to other folders, and to remove folder descendants that are only linked to the folder being deleted.
      `deleteVirtualDocumentAllDescendant` - True indicates remove the all the descendants if the object is virtual
      `policy` - When working with documents, it indicates how to handle the versions.
      `constrainedTypes` - this object to delete must belong to the type within the constrained type list; if null, no constrain. @return `true` if the object is deleted successfully
    Returns:
      whether execute successfully or fail
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### deleteSysObjectTxByQua

    boolean deleteSysObjectTxByQua(String qualification, boolean deleteFolderChildren, boolean deleteMultiLinkedFolderChildren, DeleteVersionPolicy policy, BasicType... constrainedTypes) throws com.documentum.fc.common.DfException
    This is the transactional version of `deleteSysObject(String, boolean, boolean, com.emc.documentum.rest.constant.DeleteVersionPolicy)` It supports a transactional context when the underlying object contains multiple children, this method ensures the ACID for the object.
    Parameters:
      `qualification` - the DQL qualification expression identifying the object to remove
      `deleteFolderChildren` - When working with folders, TRUE indicates to delete the folder and all of its descendants; False indicates just to delete the root folder.
      `deleteMultiLinkedFolderChildren` - When working with folders, TRUE indicates to delete the folder and all descendants, regardless of other folders into which they are linked; FALSE indicates to unlink folder descendants from the folder being deleted if the folder descendants have links to other folders, and to remove folder descendants that are only linked to the folder being deleted.
      `policy` - When working with documents, it indicates how to handle the versions.
      `constrainedTypes` - this object to delete must belong to the type within the constrained type list; if null, no constrain.
    Returns:
      whether delete successfully
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### deleteSysObjectTxByQua

    boolean deleteSysObjectTxByQua(String qualification, boolean deleteFolderChildren, boolean deleteMultiLinkedFolderChildren, boolean deleteVirtualDocumentAllDescendant, DeleteVersionPolicy policy, BasicType... constrainedTypes) throws com.documentum.fc.common.DfException
    This is the transactional version of `deleteSysObject(String, boolean, boolean, com.emc.documentum.rest.constant.DeleteVersionPolicy)` It supports a transactional context when the underlying object contains multiple children, this method ensures the ACID for the object.
    Parameters:
      `qualification` - the DQL qualification expression identifying the object to remove
      `deleteFolderChildren` - When working with folders, TRUE indicates to delete the folder and all of its descendants; False indicates just to delete the root folder.
      `deleteMultiLinkedFolderChildren` - When working with folders, TRUE indicates to delete the folder and all descendants, regardless of other folders into which they are linked; FALSE indicates to unlink folder descendants from the folder being deleted if the folder descendants have links to other folders, and to remove folder descendants that are only linked to the folder being deleted.
      `deleteVirtualDocumentAllDescendant` - True indicates remove the all the descendants if the object is virtual
      `policy` - When working with documents, it indicates how to handle the versions.
      `constrainedTypes` - this object to delete must belong to the type within the constrained type list; if null, no constrain.
    Returns:
      whether delete successfully
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkOut

    @Deprecated SysObject checkOut(String id) throws com.documentum.fc.common.DfException
    Deprecated.
    since 7.3, please use `VersioningManager.checkOut(String)`
    Check out specified object by its id
    Parameters:
      `id` - The ID of sysobject to be checked out
    Returns:
      checked out object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkOut

    @Deprecated <T extends SysObject> T checkOut(String id, Class<T> targetClass) throws com.documentum.fc.common.DfException
    Deprecated.
    since 7.3, please use `VersioningManager.checkOut(String, Class)`
    Check out specified object by its id
    Type Parameters:
      `T` - the SysObject or its subclass
    Parameters:
      `id` - The ID of sysobject to be checked out
      `targetClass` - the return class instance type for the model
    Returns:
      checked out object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### cancelCheckOut

    @Deprecated SysObject cancelCheckOut(String id) throws com.documentum.fc.common.DfException
    Deprecated.
    since 7.3, please use `VersioningManager.cancelCheckOut(String)`
    Cancel check out specified object by its id
    Parameters:
      `id` - The ID of sysobject to be cancelled
    Returns:
      cancelled object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### cancelCheckOut

    @Deprecated <T extends SysObject> T cancelCheckOut(String id, Class<T> targetClass) throws com.documentum.fc.common.DfException
    Deprecated.
    since 7.3, please use `VersioningManager.cancelCheckOut(String, Class)`
    Cancel check out specified object by its id
    Type Parameters:
      `T` - the SysObject or its subclass
    Parameters:
      `id` - The ID of sysobject to be cancelled
      `targetClass` - the return class instance type for the model
    Returns:
      cancelled object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkIn

    @Deprecated <T extends ContentfulObject> T checkIn(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, int pageNumber, String format, boolean retainLock, String comment) throws com.documentum.fc.common.DfException
    Deprecated.
    since 7.3, please use `VersioningManager.checkIn(String, ContentfulObject, String, CheckinPolicy, boolean, int, String, boolean, String)`
    Check in specified object
    Type Parameters:
      `T` - the ContentfulObject or its subclass
    Parameters:
      `chronicleId` - the root id of the version tree
      `object` - the object to be checked in, it may contains attributes need be updated
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `pageNumber` - the rendition page number
      `format` - the rendition format
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
    Returns:
      checked in object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkIn

    @Deprecated <T extends SysObject> T checkIn(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, boolean retainLock, String comment) throws com.documentum.fc.common.DfException
    Deprecated.
    since 7.3, please use `VersioningManager.checkIn(String, SysObject, String, CheckinPolicy, boolean, boolean, String)`
    Check in specified object
    Type Parameters:
      `T` - the SysObject or its subclass
    Parameters:
      `chronicleId` - the root id of the version tree
      `object` - the object to be checked in, it may contains attributes need be updated
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
    Returns:
      checked in object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkIn

    @Deprecated SysObject checkIn(String chronicleId, String id, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, InputStream contentStream, int pageNumber, String format, boolean retainLock, String comment) throws com.documentum.fc.common.DfException
    Deprecated.
    Since 7.3, please use the generic method `VersioningManager.checkIn(String, ContentfulObject, String, CheckinPolicy, boolean, int, String, boolean, String)`.
    Check in specified object
    Parameters:
      `chronicleId` - the root id of the version tree
      `id` - the object id to be checked in
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `contentStream` - the content stream
      `pageNumber` - the rendition page number
      `format` - the rendition format
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
    Returns:
      checked in object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkIn

    @Deprecated SysObject checkIn(String chronicleId, String id, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, InputStream contentStream, int pageNumber, String format, long contentLength, String charset, boolean retainLock, String comment) throws com.documentum.fc.common.DfException
    Deprecated.
    since 7.3, please use `VersioningManager.checkIn(String, String, String, CheckinPolicy, boolean, InputStream, int, String, long, String, boolean, String)`
    Check in specified object
    Parameters:
      `chronicleId` - the root id of the version tree
      `id` - the object id to be checked in
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `contentStream` - the content stream
      `pageNumber` - the rendition page number
      `format` - the rendition format
      `contentLength` - the length of the content
      `charset` - the charset of the content
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
    Returns:
      checked in object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkIn

    @Deprecated <T extends SysObject> T checkIn(String chronicleId, String id, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, InputStream contentStream, int pageNumber, String format, boolean retainLock, String comment, Class<T> targetClass) throws com.documentum.fc.common.DfException
    Deprecated.
    since 7.3, please use `VersioningManager.checkIn(String, String, String, CheckinPolicy, boolean, InputStream, int, String, boolean, String, Class)`
    Check in specified object
    Type Parameters:
      `T` - the SysObject or its subclass
    Parameters:
      `chronicleId` - the root id of the version tree
      `id` - the object id to be checked in
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `contentStream` - the content stream
      `pageNumber` - the rendition page number
      `format` - the rendition format
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
      `targetClass` - the return class instance type for the model
    Returns:
      checked in object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkInWithContents

    @Deprecated <T extends ContentfulObject> T checkInWithContents(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, int pageNumber, boolean retainLock, String comment) throws com.documentum.fc.common.DfException
    Deprecated.
    since 7.3, please use `VersioningManager.checkInWithContents(String, ContentfulObject, String, CheckinPolicy, boolean, int, boolean, String)`
    check in the object contents, the object metadata is optional. the object has more than one content to be checked in all the content will be saved as the primary content, starts from the page of pageNumber
    Type Parameters:
      `T` - the type of ContentfulObject
    Parameters:
      `chronicleId` - the root id of the version tree
      `object` - the object to be checked in
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `pageNumber` - the rendition page number
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
    Returns:
      the checked in object
    Throws:
      `com.documentum.fc.common.DfException` - any exceptions

  - ### checkInWithRenditions

    @Deprecated <T extends ContentfulObject> T checkInWithRenditions(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, int pageNumber, boolean retainLock, String comment) throws com.documentum.fc.common.DfException
    Deprecated.
    since 7.3, please use `VersioningManager.checkInWithRenditions(String, ContentfulObject, String, CheckinPolicy, boolean, int, boolean, String)`
    check in the object contents, the object metadata is optional. the object has more than one content to be checked in the first content in the content collection will be saved as the primary content, and all remaining will be saved as renditions on the specified page.
    Type Parameters:
      `T` - the type of ContentfulObject
    Parameters:
      `chronicleId` - the root id of the version tree
      `object` - the object to be checked in
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `pageNumber` - the rendition page number
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
    Returns:
      the checked in object
    Throws:
      `com.documentum.fc.common.DfException` - any exceptions

  - ### copy

    @Deprecated SysObject copy(String objectId, String folderId, boolean deepCopy, boolean replicateVdChildren) throws com.documentum.fc.common.DfException
    Deprecated.
    please use `copy(String, String, boolean, boolean, boolean, ContentfulObject)`
    Copy object into a folder
    Parameters:
      `objectId` - source object id
      `folderId` - target folder id
      `deepCopy` - if source object is a folder, whether copy its contents
      `replicateVdChildren` - if copy virtual documents in a folder with deep copy, whether copy or refer to its children
    Returns:
      copied object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### copy

    @Deprecated SysObject copy(String objectId, String folderId, boolean deepCopy, boolean replicateVdChildren, ContentfulObject object) throws com.documentum.fc.common.DfException
    Deprecated.
    please use `copy(String, String, boolean, boolean, boolean, ContentfulObject)`
    Copy object into a folder
    Parameters:
      `objectId` - source object id
      `folderId` - target folder id
      `deepCopy` - if source object is a folder, whether copy its contents
      `replicateVdChildren` - if copy virtual documents in a folder with deep copy, whether copy or refer to its children
      `object` - object contained attributes should be overwritten
    Returns:
      copied object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### copy

    @Deprecated SysObject copy(String objectId, String folderId, boolean deepCopy, boolean replicateVdChildren, boolean retainAcl, ContentfulObject object) throws com.documentum.fc.common.DfException
    Deprecated.
    since Feldspar 16.3, please use `copy(String, String, ContentfulObject, CopyOptions)`
    Copy object into a folder
    Parameters:
      `objectId` - source object id
      `folderId` - target folder id
      `deepCopy` - if source object is a folder, whether copy its contents
      `replicateVdChildren` - if copy virtual documents in a folder with deep copy, whether copy or refer to its children
      `retainAcl` - if retain cal, then the acl of the original object will be copied to the new object
      `object` - object contained attributes should be overwritten
    Returns:
      copied object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### copy

    SysObject copy(String objectId, String folderId, ContentfulObject object, com.emc.documentum.rest.dfc.util.CopyOptions copyOptions) throws com.documentum.fc.common.DfException
    Copy object into a folder
    Parameters:
      `objectId` - source object id
      `folderId` - target folder id
      `object` - object contained attributes should be overwritten
      `copyOptions` - specify the copy options
    Returns:
      copied object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### copy

    @Deprecated <T extends SysObject> T copy(String objectId, String folderId, boolean deepCopy, boolean replicateVdChildren, Class<T> targetClass) throws com.documentum.fc.common.DfException
    Deprecated.
    please use `copy(String, String, boolean, boolean, boolean, ContentfulObject)`
    Copy object into a folder.
    Type Parameters:
      `T` - the SysObject or its subclass
    Parameters:
      `objectId` - source object id
      `folderId` - target folder id
      `deepCopy` - if source object is a folder, whether copy its contents
      `replicateVdChildren` - if copy virtual documents in a folder with deep copy, whether copy or refer to its children
      `targetClass` - the return class instance type for the model
    Returns:
      copied object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### getCurrentVersion

    @Deprecated SysObject getCurrentVersion(String id) throws com.documentum.fc.common.DfException
    Deprecated.
    since 7.3, please use `VersioningManager.getCurrentVersion(String)`
    Get current object by an object id.
    Parameters:
      `id` - the object id
    Returns:
      the current version of the version tree
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### getCurrentVersion

    @Deprecated <T extends SysObject> T getCurrentVersion(String id, Class<T> targetClass) throws com.documentum.fc.common.DfException
    Deprecated.
    since 7.3, please use `VersioningManager.getCurrentVersion(String, Class)`
    Get current object by an object id.
    Type Parameters:
      `T` - the SysObject or its subclass
    Parameters:
      `id` - the object id
      `targetClass` - the return class instance type for the model
    Returns:
      the current version of the version tree
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkEnableChangePermit

    boolean checkEnableChangePermit(String objectId) throws com.documentum.fc.common.DfException
    Check whether the current login user can update the permission set of a specified sysobject.
    Parameters:
      `objectId` - the sysobject object id
    Returns:
      `true` if the user can update the object's permission set
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### toPersistentObject

    <T extends PersistentObject> T toPersistentObject(com.documentum.fc.client.IDfPersistentObject dfObject, AttributeView attributeView, Class<T> targetClass) throws com.documentum.fc.common.DfException
    Convert DFC persistent object to REST `PersistentObject` with specified attribute view applied
    Type Parameters:
      `T` - the target class
    Parameters:
      `dfObject` - DFC persistent object to convert
      `attributeView` - attribute view applied during convert
      `targetClass` - the target REST persistent object
    Returns:
      converted REST persistent object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### toPersistentObject

    <T extends PersistentObject> T toPersistentObject(com.documentum.fc.client.IDfPersistentObject dfObject, Class<T> targetClass) throws com.documentum.fc.common.DfException
    Convert DFC persistent object to REST `PersistentObject` with all attribute view applied
    Type Parameters:
      `T` - the target class
    Parameters:
      `dfObject` - DFC persistent object to convert
      `targetClass` - the target REST persistent object
    Returns:
      converted REST persistent object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### completeDcWrite

    <T extends SysObject> T completeDcWrite(String objectId, InputStream completeResponse, Class<T> targetClass) throws com.documentum.fc.common.DfException
    Complete the distributed content write.
    Type Parameters:
      `T` - the PersistentObject or its subclass
    Parameters:
      `objectId` - the sysobject ID
      `completeResponse` - the content write completion response from an ACS server or a BOCS server
      `targetClass` - the return class instance type for the model
    Returns:
      the sysobject with content write completion
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### validateAndCreateChildSysObjectRequestingDcWrite

    <T extends SysObject> T validateAndCreateChildSysObjectRequestingDcWrite(T object, String folderId, long length, String format, String netLoc, boolean async, String completionUrlBase, boolean ipBasedNetworkLocationOpted, String validationPolicy) throws com.documentum.fc.common.DfException
    Create a sysobject under the parent folder by requesting distributed content write URL(s).
    Type Parameters:
      `T` - the PersistentObject or its subclass
    Parameters:
      `object` - The persistent object with type and attributes
      `folderId` - The existing parent folder ID
      `length` - The planned primary content length to import
      `format` - The planned primary content format to import
      `netLoc` - The network location for choosing a BOCS server to import
      `completionUrlBase` - the REST completion URL base for ACS server to write back
      `async` - whether turn on the bocs sync write
      `ipBasedNetworkLocationOpted` - whether the network location selection need to be done based on client ip.
      `validationPolicy` - the constraints validation policy need to be applied on the sysobject.
    Returns:
      The newly created sysobject with ID and type only
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### getSysObjects

    Page<SysObject> getSysObjects(CollectionParam param, String objectType, boolean includeAllVersions) throws com.documentum.fc.common.DfException
    Throws:
      `com.documentum.fc.common.DfException`